//#include "../testlib/testlib.h"
#include <iostream>
#include "testlib.h"

using namespace std;
const int MAX_N = 100000;
vector<int> used;
vector<vector<int>> g;
bool cycle = false;

void has_cycle(int v, int p) {
    used[v] = 1;
    for (int u: g[v]) {
        if (u == p) {
            continue;
        }
        if (used[u] == 0) {
            has_cycle(u, v);
        } else if (used[u] == 1) {
            cycle = true;
        }
    }
    used[v] = 2;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(1, MAX_N, "n");
    inf.readEoln();

    g.assign(n, vector<int>());

    for (int i = 0; i < n - 1; i++) {
        int u = inf.readInt(1, n, "u_i");
        inf.readSpace();
        int v = inf.readInt(1, n, "v_i");
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
        inf.readEoln();
    }

    used.assign(n, 0);
    has_cycle(0, -1);

    ensuref(!cycle, "Cycle has been found in test");

    for (int i = 0; i < n; i++) {
        ensuref(used[i] > 0, "Graph is not connected");
    }

    inf.readEof();
}