/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

vector<vector<int>> g;
vector<vector<int>> dp;
vector<vector<vector<int>>> selected;

void dfs(int v, int p) {
    dp[v][0] = dp[v][1] = 0;
    for (int u : g[v]) {
        if (u == p) continue;
        dfs(u, v);

        if (dp[u][0] < dp[u][1]) {
            dp[v][0] += dp[u][1];
            selected[v][0].push_back(u);
        } else {
            dp[v][0] += dp[u][0];
        }

        if (dp[u][0] + 1 < dp[u][1]) {
            dp[v][1] += dp[u][1];
            selected[v][1].push_back(u);
        } else {
            dp[v][1] += dp[u][0] + 1;
        }
    }
}

vector<int> answer;

void collect(int v, int p, bool flag) {
    if (flag) {
        answer.push_back(v);
    }
    int it = 0;
    for (int u : g[v]) {
        if (u == p) continue;
        if (it < selected[v][flag].size() && selected[v][flag][it] == u) {
            collect(u, v, true);
            it++;
        } else {
            collect(u, v, false);
        }
    }
}

int main() {

    in(int, n)
    g.resize(n);
    dp.assign(n, vector<int>(2));
    selected.assign(n, vector<vector<int>>(2));

    for (int i = 1; i < n; i++) {
        in(int, u, v)
        g[--u].push_back(--v);
        g[v].push_back(u);
    }

    dfs(0, -1);
    collect(0, -1, dp[0][1] > dp[0][0]);
    sort(all(answer));

    cout << max(dp[0][0], dp[0][1]) << ' ' << answer.size() << '\n';
    for (int v : answer) {
        cout << v + 1 << ' ';
    }
    cout << '\n';

}