#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

struct edge {
    int from, to, a, b;
};

int n;
vector<edge> edges;
int const W_MAX = 1e6;

bool check(InStream &in) {
    int w = in.readInt(-1, W_MAX, "w");
    if (w == -1) return false;
    in.ensuref(w >= 1, "if w > -1, w should be positive");

    vector<int> d_in(n), d_out(n);
    for (int i = 0; i < n; i++) {
        int edge_id = in.readInt(1, 2 * n, format("edge number %d", i + 1)) - 1;
        auto const &e = edges[edge_id];
        d_out[e.from]++;
        d_in[e.to]++;
        in.ensuref(e.a <= w, "selected weight is less than min on edge %d", i + 1);
        in.ensuref(w <= e.b, "selected weight is greater than max on edge %d", i + 1);
    }
    for (int i = 0; i < n; i++) {
        in.ensuref(d_in[i] == 1, "vertex %d doesn't have deg_in = 1", i + 1);
        in.ensuref(d_out[i] == 1, "vertex %d doesn't have deg_out = 1", i + 1);
    }
    return true;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    for (int i = 0; i < 2 * n; i++) {
        int from = i / 2;
        int to = inf.readInt(), a = inf.readInt(), b = inf.readInt();
        edges.push_back(edge{from, --to, a, b});
    }

    bool ja = check(ans), pa = check(ouf);
    if (!ja && pa) quitf(_fail, "participant has answer but jury doesn't");
    if (ja && !pa) quitf(_wa, "jury has answer but participant doesn't");

    quitf(_ok, "all checks passed");

}