#include <numeric>
#include "testlib.h"

using namespace std;

#define all(c) c.begin(), c.end()

bool valid(vector<int> const &targets) {
    for (int i = 0; i < targets.size(); i++) {
        if (targets[i] == i) return false;
    }
    return true;
}

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), a = opt<int>("a"), b = opt<int>("b"), batch = opt<int>("batch");
    int mid = (a + b) / 2;

    vector<int> go(n);
    int last = 0;
    for (int i = 0; i < n; i++) {
        if (i > last && (!rnd.next(batch) || i == n - 1)) {
            go[i] = last;
            last = i + 1;
        } else {
            go[i] = i + 1;
        }
    }
    if (last == n - 1) {
        go.push_back(n - 1);
        n++;
    }

    vector<int> p(n), pr(n), extra(n);
    iota(all(p), 0);
    iota(all(extra), 0);
    shuffle(all(p));
    for (int i = 0; i < n; i++) {
        pr[p[i]] = i;
    }
    while (!valid(extra)) {
        shuffle(all(extra));
    }

    println(n);
    for (int i = 0; i < n; i++) {
        int l = rnd.next(a, (2 * mid + b) / 3), r = rnd.next((2 * mid + a) / 3, b);
        if (l > r) swap(l, r);
        auto e1 = {p[go[pr[i]]] + 1, l, r};
        int ai = rnd.next(a, b), bi = rnd.next(a, b);
        if (ai > bi) swap(ai, bi);
        auto e2 = {p[extra[pr[i]]] + 1, ai, bi};
        if (rnd.next(2)) {
            swap(e1, e2);
        }
        println(all(e1));
        println(all(e2));
    }

}