#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const MAX_N = 100'000;
    int const MAX_W = 100'000;

    int n = inf.readInt(3, MAX_N, "n");
    inf.readEoln();

    vector<int> d_in(n);
    for (int i = 0; i < 2 * n; i++) {
        int to = inf.readInt(1, n, format("to_%d", i + 1)) - 1;
        ensuref(to != i / 2, "target vertex can't be the same as source vertex on edge %d", i + 1);
        inf.readSpace();
        int a = inf.readInt(1, MAX_W, format("a_%d", i + 1));
        inf.readSpace();
        int b = inf.readInt(1, MAX_W, format("b_%d", i + 1));
        inf.readEoln();

        ensuref(a <= b, "a should be not greater than b on edge %d", i + 1);
        d_in[to]++;
    }
    for (int i = 0; i < n; i++) {
        ensuref(d_in[i] == 2, "deg_in(%d) should be equal to 2", i + 1);
    }

    inf.readEof();

}