/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

struct edge {
    int from, to, a, b;
};

typedef vector<vector<int>> graph;
vector<int> out;
vector<int> vis, comp;

void dfs1(graph const &g, int v) {
    vis[v] = true;
    for (int u : g[v]) {
        if (!vis[u]) dfs1(g, u);
    }
    out.push_back(v);
}

void dfs2(graph const &g, int v, int c) {
    comp[v] = c;
    for (int u : g[v]) {
        if (comp[u] == -1) dfs2(g, u, c);
    }
}

int main() {

    in(int, n)
    int m = 2 * n;
    vector<edge> edges(m);
    vector<vector<int>> d_in(n);
    int max_b = 0;

    for (int i = 0; i < m; i++) {
        int from = i / 2;
        in(int, to, a, b);
        edges[i] = edge{from, --to, a, b};
        d_in[to].push_back(i);
        max_b = max(max_b, b + 1);
    }

    int total = m + max_b;
    // m x edges, max_b x le, m x !edges, max_b x !le
    graph g(2 * total), gt(2 * total);
    for (int i = 0; i < n; i++) {
        g[2 * i].push_back((2 * i + 1) + total);
        g[2 * i + 1].push_back((2 * i) + total);
        g[(2 * i) + total].push_back(2 * i + 1);
        g[(2 * i + 1) + total].push_back(2 * i);

        g[d_in[i][0]].push_back(d_in[i][1] + total);
        g[d_in[i][1]].push_back(d_in[i][0] + total);
        g[d_in[i][0] + total].push_back(d_in[i][1]);
        g[d_in[i][1] + total].push_back(d_in[i][0]);
    }
    for (int i = 0; i < m; i++) {
        g[i].push_back((m + edges[i].a - 1) + total);
        g[(m + edges[i].a - 1)].push_back(i + total);
        g[i].push_back(m + edges[i].b);
        g[(m + edges[i].b) + total].push_back(i + total);
    }
    for (int i = 0; i < max_b - 1; i++) {
        g[m + i].push_back(m + i + 1);
        g[(m + i + 1) + total].push_back((m + i) + total);
    }

    for (int i = 0; i < g.size(); i++) {
        for (int j : g[i]) {
            gt[j].push_back(i);
        }
    }

    vis.assign(total * 2, 0);
    for (int v = 0; v < total * 2; v++) {
        if (!vis[v]) dfs1(g, v);
    }
    reverse(all(out));
    comp.assign(total * 2, -1);
    int c = 0;
    for (int v : out) {
        if (comp[v] == -1) dfs2(gt, v, c++);
    }

    vector<int> select(total);
    int w = 0;
    for (int i = 0; i < total; i++) {
        int ni = i + total;
        if (comp[i] == comp[ni]) {
            cout << -1 << '\n';
            return 0;
        }
        select[i] = comp[i] > comp[ni];
    }
    while (!select[m + w]) w++;

    cout << w << '\n';
    for (int i = 0; i < m; i++) {
        if (select[i]) {
            cout << i + 1 << ' ';
        }
    }
    cout << '\n';

}