#include "testlib.h"

using namespace std;

typedef long long ll;

int readAnswer(InStream &inStream, int n, vector<pair<int, int>> &points) {
    int answer = inStream.readInt(0, n, "ans");
    inStream.readEoln();

    vector<int> ebp;
    for (int i = 0; i < answer; ++i) {
        ebp.push_back(inStream.readInt(1, n, "pi"));
    }

    for (int i = 1; i < answer; ++i) {
        inStream.ensuref(
                points[ebp[i - 1] - 1].first <= points[ebp[i] - 1].first &&
                points[ebp[i - 1] - 1].second <= points[ebp[i] - 1].second ||
                points[ebp[i - 1] - 1].first <= points[ebp[i] - 1].second &&
                points[ebp[i - 1] - 1].second <= points[ebp[i] - 1].first,
                "point %d should can include into points %d", ebp[i - 1], ebp[i]
        );
    }
    return answer;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    vector<pair<int, int>> points(n);
    for (int i = 0; i < n; ++i) {
        points[i].first = inf.readInt();
        points[i].second = inf.readInt();
    }

    ll juryAnswer = readAnswer(ans, n, points);
    ll pAnswer = readAnswer(ouf, n, points);
    if (juryAnswer < pAnswer) {
        quitf(_fail, "participant's answer %lld is better than jury's", pAnswer);
    }
    if (juryAnswer > pAnswer) {
        quitf(_wa, "jury's answer is better than participant's %lld", pAnswer);
    }
    quitf(_ok, "%lld", juryAnswer);
}
