using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const int MAX_L = 1000000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int max_n = opt<int>("n");
    int n = 1 + rnd.wnext(max_n, 10);

    printf("%d\n", n);

    const int max_l = has_opt("l") ? opt<int>("l") : MAX_L;
    int cx = 1 + rnd.wnext((int) sqrt(max_l), -10);
    int cy = 1 + rnd.wnext((int) sqrt(max_l), -10);

    vector <pair<int, int>> a;
    while (a.size() < n) {
        int m = rnd.next(0, 3);
        int x;
        int y;
        if (m == 0) {
            x = rnd.next(1, max_l);
            y = rnd.next(1, max_l);
        } else if (m == 1) {
            x = cx = rnd.next(cx, min(max_l, cx * 2));
            y = cy = rnd.next(cy, min(max_l, cy * 2));
        } else if (m == 2) {
            x = rnd.next(1, max(1, cx - 1));
            y = rnd.next(min(max_l, cy + 1), min(max_l, cy * 2));
        } else {
            int mx = max(cx, cy);
            x = cx = rnd.next(mx, min(max_l, mx * 2));
            y = cy = cx;
        }
        a.emplace_back(x, y);
    }

    shuffle(a.begin(), a.end());
    
    for (int i = 0; i < n; ++i) {
        if (rnd.next(0, 1)) {
            swap(a[i].first, a[i].second);
        }
        printf("%d %d\n", a[i].first, a[i].second);
    }

    return 0;
}
