#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

const int max_n = 100'000;
const int max_m = 200'000;
const int max_a = 1'000'000'000;
const long long max_sum_a = 1000'000'000'000LL;
const int max_w = 1'000'000'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, max_n, "n");
    inf.readSpace();
    int m = inf.readInt(1, max_m, "m");
    inf.readSpace();
    inf.readInt(1, n, "s");
    inf.readEoln();

    vector<int> a = inf.readInts(n, 1, max_a, "a_i");
    inf.readEoln();
    long long a_sum = 0;
    for (long long ai: a) {
        a_sum += ai;
    }
    ensuref(a_sum <= max_sum_a, "sum of a_i should be less than %lld", max_sum_a);

    set<pair<int, int >> was_edge;
    for (int i = 0; i < m; ++i) {
        int u = inf.readInt(1, n, "u_i");
        inf.readSpace();
        int v = inf.readInt(1, n, "v_i");
        inf.readSpace();
        inf.readInt(1, max_w, "w_i");
        inf.readEoln();

        ensuref(u != v, "should no be eges from %d to %d", u, v);

        if (u > v) { swap(u, v); }
        ensuref(was_edge.find(make_pair(u, v)) == was_edge.end(), "should no be even edge from %d to %d", u, v);
        was_edge.emplace(u, v);
    }
    inf.readEof();
}