using namespace std;

#include <iostream>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>

using ll = long long;
#define X first
#define Y second

class DSU {
    vector<int> p, w;
    vector<ll> s;
public:
    DSU(int n) : p(n + 1), w(n + 1, 0), s(n + 1) {
        for (int i = 1; i <= n; ++i) {
            p[i] = i;
        }
    }

    ll &value(int v) {
        return s[v];
    }

    ll sum(int v) {
        return s[find(v)];
    }

    int find(int v) {
        while (p[v] != v) {
            v = p[v];
        }
        return v;
    }

    void join(int a, int b) {
        a = find(a);
        b = find(b);
        if (a == b) return;
        if (w[a] == w[b]) w[a]++;
        if (w[a] < w[b]) {
            p[a] = b;
            s[b] += s[a];
        } else {
            p[b] = a;
            s[a] += s[b];
        }
    }
};


int main() {
    int n, m, s;
    cin >> n >> m >> s;
    --s;

    DSU dsu(n);

    vector <ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        dsu.value(i) = a[i];
    }

    vector < pair < ll, pair < int, int>>> edges;
    for (int j = 0; j < m; ++j) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        edges.emplace_back(w, make_pair(u, v));
    }
    sort(edges.begin(), edges.end());

    ll f = a[s];
    for (auto [w, nodes]: edges) {
        if (w > f) {
            break;
        }
        f -= dsu.sum(s);
        dsu.join(nodes.X, nodes.Y);
        f += dsu.sum(s);
    }

    cout << f << "\n";
}