#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

#define all(c) c.begin(), c.end()

int n, m;

int check(vector<vector<int>> table, InStream &in) {
    int r = in.readInt(-1, n, "r");
    if (r == -1) return -1;
    int c = in.readInt(0, m, "c");

    auto ri = in.readInts(r, 1, n, "row numbers"), ci = in.readInts(c, 1, m, "column numbers");
    in.ensuref(ri.size() == set<int>(all(ri)).size(),
               "repeating row numbers");
    in.ensuref(ci.size() == set<int>(all(ci)).size(),
               "repeating column numbers");

    vector<int> rmod(n, 0), cmod(m, 0);
    for (int rid : ri) rmod[--rid] = 1;
    for (int cid : ci) cmod[--cid] = 1;
    vector<vector<int>> reach(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            table[i][j] ^= rmod[i] ^ cmod[j];
            reach[i][j] = table[i][j];
            int parent = i == 0 && j == 0;
            if (i > 0) parent |= reach[i - 1][j];
            if (j > 0) parent |= reach[i][j - 1];
            reach[i][j] &= parent;
        }
    }

    in.ensuref(reach[n - 1][m - 1], "target cell is unreachable");
    return r + c;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    m = inf.readInt();
    inf.readLine();
    vector<vector<int>> table(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        auto row = inf.readLine();
        for (int j = 0; j < m; j++) {
            table[i][j] = row[j] - '0';
        }
    }

    int ja = check(table, ans), pa = check(table, ouf);
    if (ja == -1 && pa != -1) quitf(_fail, "participant has answer, jury doesn't");
    if (ja != -1 && pa == -1) quitf(_wa, "jury has answer, participant doesn't");
    if (ja > pa) quitf(_fail, "participant has better answer %d than jury's %d", pa, ja);
    if (ja < pa) quitf(_wa, "jury has better answer %d than participant's %d", pa, ja);

    quitf(_ok, "all checks passed");

}