//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m;
  cin >> n >> m;
  vector a(n, vector<int>(m));
  for (int i = 0; i < n; ++i) {
    string s; cin >> s;
    for (int j = 0; j < m; ++j) {
      a[i][j] = (s[j] - '0') ^ 1;
    }
  }
  int const INF = 1e9;
  vector dp(n, vector(m, vector<int>(2, INF)));
  dp[0][0][0] = a[0][0];
  dp[0][0][1] = 1 + (a[0][0] ^ 1);
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      for (int fr = 0; fr < 2; ++fr) {
        if (i + 1 < n) {
          int fc = fr ^ a[i][j];
          int nr = fc ^ a[i + 1][j];
          smin(dp[i + 1][j][nr], dp[i][j][fr] + nr);
        }
        if (j + 1 < m) {
          smin(dp[i][j + 1][fr], dp[i][j][fr] + (a[i][j + 1] ^ fr));
        }
      }
    }
  }
  int i = n - 1;
  int j = m - 1;
  int fr = (dp[i][j][0] < dp[i][j][1] ? 0 : 1);
  vector<int> r, c;
  while (i > 0 || j > 0) {
    int fromRow = (j == 0 ? INF : dp[i][j - 1][fr] + (a[i][j] ^ fr));
    int fromCol = (i == 0 ? INF : dp[i - 1][j][fr ^ a[i][j] ^ a[i - 1][j]] + fr);
    if (fromRow < fromCol) {
      if (a[i][j] ^ fr) {
        c.push_back(j);
      }
      --j;
    } else {
      if (fr) {
        r.push_back(i);
      }
      fr ^= a[i][j] ^ a[i - 1][j];
      --i;
    }
  }
  if (fr) {
    r.push_back(0);
  }
  if (fr ^ a[0][0]) {
    c.push_back(0);
  }
  cout << r.size() << ' ' << c.size() << '\n';
  for (int x : r) {
    cout << x + 1 << ' ';
  }
  cout << '\n';
  for (int x : c) {
    cout << x + 1 << ' ';
  }
  cout << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
