#include "testlib.h"

using namespace std;

typedef long long ll;
const int MAX_QUERIES = 42;

int readAnswer(InStream &inStream, int n, const vector<int> &a, int c) {
    inStream.readToken("answer", "_");
    int answer = inStream.readInt(0, n - 1, "ans");

    // for (int i = 0; i < n; ++i) {
        // inStream.ensuref(a[(i + c) % n] == a[(i + answer) % n], "incorrect answer for x = %d", i + 1);
    // }

    inStream.readToken("queries", "_");
    int queries = inStream.readInt(0, INT_MAX, "queries");
    inStream.ensuref(queries < MAX_QUERIES, "too match queries was done (%d)", queries);

    return answer;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int c = inf.readInt();
    vector<int> a = inf.readInts(n);

    ll juryAnswer = readAnswer(ans, n, a, c);
    ll pAnswer = readAnswer(ouf, n, a, c);
    if (juryAnswer != c) {
        quitf(_fail, "jury's answer is not equal to c");
    }
    if (pAnswer != c) {
        quitf(_wa, "participant's answer is not equal to c");
    }
    quitf(_ok, "%lld", juryAnswer);
}
