using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const int MAX_XYR = 100000;

ll sqr(ll a) {
    return a * a;
}

double dist(ll x, ll y) {
    return sqrt((double) (sqr(x) + sqr(y)));
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int max_n = opt<int>("n");
    int n = 1 + rnd.wnext(max_n, 10);

    const int max_xy = has_opt("x") ? opt<int>("x") : MAX_XYR;
    const int max_r = has_opt("r") ? opt<int>("r") : MAX_XYR;

    int fix_x = has_opt("fx") ? opt<int>("fx") : 0;
    int fix_y = has_opt("fy") ? opt<int>("fy") : 0;

    printf("%d\n", n);

    for (int i = 0; i < n; ++i) {
        int x = 1 + rnd.wnext(max_xy, 10);
        x = fix_x != 0 ? fix_x * x : (rnd.next(0, 1) ? x : -x);

        int y = 1 + rnd.wnext(max_xy, 10);
        y = fix_y != 0 ? fix_y * y : (rnd.next(0, 1) ? y : -y);

        int read_d = int(dist(x, y));

        int r = 1 + rnd.wnext(min(max_r, read_d - 1), -20);
        printf("%d %d %d\n", x, y, r);
    }

    return 0;
}
