#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

const int max_n = 100'000;
const int max_x = 100'000;

long long distSqr(long long x, long long y) {
    return (x * x) + (y * y);
}

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, max_n, "n");
    inf.readEoln();

    for (int i = 0; i < n; ++i) {
        int x = inf.readInt(-max_x, max_x, "x_i");
        inf.readSpace();
        int y = inf.readInt(-max_x, max_x, "y_i");
        inf.readSpace();
        int r = inf.readInt(1, max_x, "r_i");
        inf.readEoln();

        ensuref(x != 0 || y != 0, "centre of circle can't be in (0,0)");
        ensuref(x != 0 || y != 0, "centre of circle can't be in (0,0)");
        ensuref((long long) (r) * (long long) (r) < distSqr(x, y),
                "radius of circle should be less than distance from centre");
    }
    inf.readEof();
}