using namespace std;

#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <cmath>

#define X first
#define Y second
#define mp make_pair
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);

const double PI = acos(-1);

using ll = long long;
using point = pair<ll, ll>;

ll sqr(ll a) {
    return a * a;
}

double dist(ll x, ll y) {
    return sqrt((double) (sqr(x) + sqr(y)));
}

double dist(const point &a, const point &b) {
    return dist(a.X - b.X, a.Y - b.Y);
}

double nangle(double an) {
    return an >= 0 ? an : (an + PI * 2);
}

double angle(const point &a, const point &b) {
    double an = atan2(a.X * b.Y - b.X * a.Y, a.X * b.X + a.Y * b.Y);
    return nangle(an);
}

int main() {
//    fastio;
    int n;
    cin >> n;

    vector <pair<double, int>> events;

    int cur = 0;
    for (int i = 0; i < n; ++i) {
        ll x, y;
        double r;
        cin >> x >> y >> r;
        double len = dist(x, y);

        double dir = angle(mp(x, y), mp(0, 1));
        double ar = asin(double(r) / double(len));

        double begin = nangle(dir - ar);
        double end = nangle(dir + ar);
        if (begin > end) { ++cur; }
        events.emplace_back(begin, 1);
        events.emplace_back(end, -1);
//        cout << i << " " << dir << " " << ar << " " << r << "/" << len << "\n";
    }
//    cout << PI;


    double closed = 0;

    sort(events.begin(), events.end());
    double from = 0;
    for (auto [pos, d]: events) {
//        cout << pos << " " << d << "\n";
        if (d > 0 && cur == 0) {
            from = pos;
        }
        if (d < 0 && cur == 1) {
            closed += pos - from;
        }

        cur += d;

    }
    if (cur > 0) {
        closed += 2 * PI - from;
    }
    cout << setprecision(7) << fixed << (1 - closed / (2 * PI)) << "\n";
}