//#include "../testlib/testlib.h"
#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;
int n;

int countCost(string &s) {
    map<char, int> freq;
    for (char c: s) {
        freq[c]++;
    }

    vector<pair<char, int> > letters;
    for (const auto &p: freq) {
        letters.emplace_back(p);
    }

    sort(letters.begin(), letters.end(), [&](const auto &a, const auto &b) {
        return a.second > b.second;
    });

    int cost = 0;
    for (int i = 0; i < letters.size(); i++) {
        cost += (i + 1) * letters[i].second;
    }

    return cost;
}

int main(int argc, char *argv[]){
    registerTestlibCmd(argc, argv);

    n = inf.readInt(1, 100000, "n");

    string part = ouf.readLine("[a-z]{" + toString(n) + "}", "part_ans");
    string jury = ans.readLine("[a-z]{" + toString(n) + "}", "jury_ans");

    int cost_p = countCost(part);
    int cost_j = countCost(jury);

    if (cost_p < cost_j) {
        quitf(_wa, "Jury found better answer");
    } else if (cost_p == cost_j) {
        quitf(_ok, "test passed");
    } else {
        quitf(_fail, "Participant found better answer");
    }
}